c.previousSibling.textContent = "click pls";
onclick = () => {
onclick = null;
c.parentElement.innerHTML = `<canvas id=c>`;
c.parentElement.style.margin = 0;
c.parentElement.style.cursor = `none`;
c.width = 1920;
c.height = 1080;
debug(function() {
    c.parentElement.innerHTML += `<input id=time></input>`;
});

// time incremented by audio player in audio frames (and in seconds)
// + audio filter
f = t = filterLow = filterBand = filterHigh = drumPhase = 0;

let sineWave =(sec, freq) =>{
    var dur = 1. / freq;
    return Math.sin(2 * Math.PI * (sec % dur) * freq);
}

let squareWave = (sec, freq) =>{
    var dur = 1. / freq;
    return (sec % dur) * freq < 0.5 ? -1 : 1;
}

let sawtoothWave = (sec, freq) =>{
    var dur = 1. / freq;
    return ((sec % dur) * freq) * 2 - 1;
}

let noiseWave = () => {
    return Math.random() * 2 - 1;
}

//let linDecay = (sec, decayTime) =>
//    sec < 0 ? 1 :
//    (sec /= decayTime) > 1 ? 0 : 1 - sec;
//
//let linAttack = (sec, attackTime) =>
//    sec < 0 ? 0 :
//    (sec /= attackTime) > 1 ? 1 : sec;

let expDecay = (sec, decayTime) =>
    sec < 0 ? 1 :
    (sec /= decayTime) > 1 ? 0 : Math.exp(-4.6 * sec);

// Readable version:
//let expDecay = (sec, decayTime, startTime) => {
//    if (sec < startTime)
//        return 1;
//    sec -= startTime;
//    if (sec > decayTime)
//        return 0;
//    var EPSILON = 0.01;
//    var b = Math.log(EPSILON) / decayTime;
//    return Math.exp(b * sec);
//}

let expAttack = (sec, attackTime) =>
    sec < 0 ? 0 :
    (sec /= attackTime) > 1 ? 1 : 0.01 * Math.exp(4.6 * sec);

// Readable version:
//let expAttack = (sec, attackTime, startTime) => {
//    if (sec < startTime)
//        return 0;
//    sec -= startTime;
//    if (sec > attackTime)
//        return 1;
//    var EPSILON = 0.01;
//    var b = Math.log(1/EPSILON) / attackTime;
//    return EPSILON * Math.exp(b * sec);
//}

// audio setup
audioContext = new AudioContext;
audioScriptProcessor = audioContext.createScriptProcessor(1024, 1, 1);
audioScriptProcessor.connect(audioContext.destination);
audioScriptProcessor.onaudioprocess = audioEvent =>
    audioEvent.outputBuffer.getChannelData(0).map((_, i) => {
        t = f++ / 44100;
        let ts = t % 0.5;
        let sample = 0;

        // wind noise
        let timeConst = 3;
        let windSample = noiseWave() * expAttack(t, timeConst) * Math.max(0.4, expDecay(t - 3 * timeConst, timeConst));
        let filterCutoff = 2500 - 80 * Math.max(0, Math.min(t, 22) - 8);
        let filterF = filterCutoff * Math.PI / 44100;
        let q = 0.063;
        filterF *= Math.sin(2 * Math.PI * 0.001 * t) * 0.1 + 0.5;
        filterF = 1.5 * Math.sin(filterF);
        filterLow += filterF * filterBand;
        filterHigh = q * (windSample - filterBand) - filterLow;
        filterBand += filterF * filterHigh;
        sample += filterLow * 10.;


        if (t < 16 || t > 24) {
            // drum 1
            let drum1Freq = t < 12 ? 260 : 520;
            let env = expAttack(ts, 0.0015) * expDecay(ts - 0.0048, 0.1115);
            drumPhase += env * env * Math.PI * 2 * drum1Freq / 44100;
            sample += expAttack(t - 5, 3) * env * Math.sin(drumPhase) * 1.8;
        } else {
            // drum 2
            let drum2Freq = t < 20 ? 200 : 100;
            let drum2Len = t < 20 ? 1 : 0.2;
            sample += 0.1 * squareWave(ts, drum2Freq * expDecay(ts, 1)) * expAttack(ts, 0.01) * expDecay(ts - 0.08, 0.3);
            ts -= 0.25;
            sample += 0.1 * noiseWave() * expDecay(ts, drum2Len) * expAttack(ts, 0.01) * expDecay(ts-0.08, 0.2);
        }
        audioEvent.outputBuffer.getChannelData(0)[i] = (t<35) * sample * 0.2 * expDecay(t - 28, 32);
    })

gl = c.getContext`webgl`;
shaderProgram = gl.createProgram();

shader = gl.createShader(GL_VERTEX_SHADER);
gl.shaderSource(shader, `attribute vec4 p;void main(){gl_Position=p;}`);
gl.compileShader(shader);
gl.attachShader(shaderProgram, shader);

shader = gl.createShader(GL_FRAGMENT_SHADER);
// FRAG_SHADER_SOURCE is either assigned in uncompressed.html or replaced inline by Makefile
debug(function() {
    // Work around minifier shit (does not understand precision statement)
    FRAG_SHADER_SOURCE = "precision lowp float;" + FRAG_SHADER_SOURCE;
});
gl.shaderSource(shader, FRAG_SHADER_SOURCE);
gl.compileShader(shader);
gl.attachShader(shaderProgram, shader);

gl.linkProgram(shaderProgram);
gl.useProgram(shaderProgram);

debug(function() {
    if (!gl.getShaderParameter(shader, gl.COMPILE_STATUS)) {
        let error = gl.getShaderInfoLog(shader);
        console.log(error);
        throw 666;
    }
});

gl.bindBuffer(GL_ARRAY_BUFFER, gl.createBuffer());
gl.bufferData(GL_ARRAY_BUFFER,
    Int8Array.of(-3, 1, 1, -3, 1, 1),
    GL_STATIC_DRAW); /* can be DYNAMIC_DRAW as well I guess */
gl.enableVertexAttribArray(0);
gl.vertexAttribPointer(
    0, /* vertex attribute index */
    2, /* number of components */
    gl.BYTE, /* must match array type */
    0, /* normalized, must be 0 I guess? */
    0, /* stride ?!?! */
    0); /* offset */

render = _ => {
    gl.uniform1f(gl.getUniformLocation(shaderProgram, `t`), t);
    gl.drawArrays(GL_TRIANGLE_FAN, /* could probably be TRIANGLES as well */
        0, /* first index */
        3); /* number of points */
    requestAnimationFrame(render);
    debug(function() {
        document.getElementById('time').value = t;
    });
};
render();
}
